const API_PORT = 8128;

const ENDPOINT_TORQUE_PING = "/ping";
const ENDPOINT_TORQUE_METRICS = "/metrics";
const ENDPOINT_TORQUE = "/api/torque";

const CONFIG_FILE = "./config.json";

const TORQUE_STATS_RESPONSE_CONTENT = "OK!";

const TORQUE_METRIC_LABEL_TIME = "time";
const TORQUE_METRIC_LABEL_EML = "eml";
const TORQUE_METRIC_LABEL_EMAIL = "email";
const TORQUE_METRIC_LABEL_ID = "id";
const TORQUE_METRIC_LABEL_SESSION = "session";
const TORQUE_METRIC_LABEL_V = "v";
const TORQUE_METRIC_LABEL_VERSION = "version";
const TORQUE_METRIC_LABEL_DEVICE = "device";

const TORQUE_METRIC_NAME = "torque_obd_sensor";
const TORQUE_METRIC_DESCRIPTION = "Torque OBDII Sensor";

const TORQUE_METRIC_GEOHASH_NAME = "torque_device_location";
const TORQUE_METRIC_GEOHASH_DESCRIPTION = "Torque Device Location";

const MESSAGE_TYPE_DEFAULT_METADATA = "defaultMetadata";
const MESSAGE_TYPE_USER_METADATA = "userMetadata";
const MESSAGE_TYPE_DATA = "data";

const PID_DEFAULT_UNIT = "defaultUnit";
const PID_MAPPING = "mapping";
const PID_UNIT = "unit";
const PID_NAME = "name";
const PID_DESCRIPTION = "description";

const PID_GPS_LONGITUDE = "ff1005";
const PID_GPS_LONGITUDE_NAME = "longitude";

const PID_GPS_LATITUDE = "ff1006";
const PID_GPS_LATITUDE_NAME = "latitude";

const TORQUE_METRIC_LABEL_GEOHASH = "geohash";

const METRIC_VALUE_KEY = "value";

const TORQUE_METRIC_LABEL_CLEAN = [
  TORQUE_METRIC_LABEL_EMAIL,
  TORQUE_METRIC_LABEL_TIME,
];

const TORQUE_METRIC_LABELS = [
  TORQUE_METRIC_LABEL_EMAIL,
  TORQUE_METRIC_LABEL_ID,
  TORQUE_METRIC_LABEL_SESSION,
  TORQUE_METRIC_LABEL_VERSION,
  TORQUE_METRIC_LABEL_DEVICE,
  PID_UNIT,
  PID_NAME,
  PID_DESCRIPTION,
];

const TORQUE_METRIC_GEOHASH_LABELS = [
    TORQUE_METRIC_LABEL_EMAIL,
    TORQUE_METRIC_LABEL_ID,
    TORQUE_METRIC_LABEL_SESSION,
    TORQUE_METRIC_LABEL_VERSION,
    TORQUE_METRIC_LABEL_DEVICE,
    TORQUE_METRIC_LABEL_GEOHASH
  ];

const METADATA_FIELDS = {
  [TORQUE_METRIC_LABEL_TIME]: TORQUE_METRIC_LABEL_TIME,
  [TORQUE_METRIC_LABEL_EML]: TORQUE_METRIC_LABEL_EMAIL,
  [TORQUE_METRIC_LABEL_SESSION]: [TORQUE_METRIC_LABEL_SESSION],
  [TORQUE_METRIC_LABEL_ID]: TORQUE_METRIC_LABEL_ID,
  [TORQUE_METRIC_LABEL_V]: [TORQUE_METRIC_LABEL_VERSION],
};

const MESSAGE_TYPE = {
  default: MESSAGE_TYPE_DEFAULT_METADATA,
  user: MESSAGE_TYPE_USER_METADATA,
  k: MESSAGE_TYPE_DATA,
};

const PID_FIELDS = [PID_DEFAULT_UNIT, PID_MAPPING];

const PID_METADATA = {
  userUnit: PID_UNIT,
  userShortName: PID_NAME,
  userFullName: PID_DESCRIPTION,
};

const TORQUE_METRIC_GAUGE = {
  name: TORQUE_METRIC_NAME,
  help: TORQUE_METRIC_DESCRIPTION,
  labelNames: TORQUE_METRIC_LABELS,
};

const TORQUE_METRIC_GEOHASH_GAUGE = {
  name: TORQUE_METRIC_GEOHASH_NAME,
  help: TORQUE_METRIC_GEOHASH_DESCRIPTION,
  labelNames: TORQUE_METRIC_GEOHASH_LABELS,
};

const TORQUE_IGNORE_PIDS = ["kff1007"];

module.exports = {
  API_PORT,
  ENDPOINT_TORQUE,
  CONFIG_FILE,
  TORQUE_STATS_RESPONSE_CONTENT,
  ENDPOINT_TORQUE_METRICS,
  METADATA_FIELDS,
  MESSAGE_TYPE,
  PID_FIELDS,
  PID_METADATA,
  TORQUE_METRIC_LABELS,
  MESSAGE_TYPE_DEFAULT_METADATA,
  MESSAGE_TYPE_USER_METADATA,
  MESSAGE_TYPE_DATA,
  PID_DEFAULT_UNIT,
  PID_MAPPING,
  PID_UNIT,
  TORQUE_METRIC_LABEL_EML,
  TORQUE_METRIC_LABEL_EMAIL,
  TORQUE_METRIC_LABEL_ID,
  TORQUE_METRIC_LABEL_SESSION,
  TORQUE_METRIC_LABEL_V,
  TORQUE_METRIC_LABEL_VERSION,
  TORQUE_METRIC_LABEL_DEVICE,
  TORQUE_METRIC_NAME,
  TORQUE_METRIC_DESCRIPTION,
  TORQUE_METRIC_GAUGE,
  TORQUE_METRIC_LABEL_TIME,
  METRIC_VALUE_KEY,
  TORQUE_METRIC_LABEL_CLEAN,
  ENDPOINT_TORQUE_PING,
  TORQUE_IGNORE_PIDS,
  PID_GPS_LONGITUDE,
  PID_GPS_LONGITUDE_NAME,
  PID_GPS_LATITUDE,
  PID_GPS_LATITUDE_NAME,
  TORQUE_METRIC_LABEL_GEOHASH,
  TORQUE_METRIC_GEOHASH_GAUGE
};
